//<c>   Copyright 1990-1999 by Gerry J. Danen; all rights reserved.

//<t>   Word count

#include"gd_tools.h"


#define BUFSIZE 8192
char    buf[BUFSIZE], buf1[BUFSIZE], word[BUFSIZE] ;


BOOL    bytes = FALSE, words = FALSE, lines = FALSE, files = FALSE ;
BOOL    inword, word_done ;
long    tkc, tkl, tkw ;
UINT    siz_out = 2 ;                   //  words >= siz_out go to output file
FILE    *iFh, *oFh ;
STRING  oFile = "wc.wrd" ;


void    wc( char *f )
{
    long        kc, kl, kw ;
    int         count ;
    register    i, w ;
    char        *p ;

    kc = kw = kl = 0L ;
    ST_CLR( word );
    w = 0 ;
    while ( (p = fgets( buf1, BUFSIZE, iFh )) )
    {
        inword = word_done = FALSE ;
        StrDetab( buf, buf1, BUFSIZE );
        kc += (1 + strlen(buf));
        kl += 1 ;
        st_xlate( buf, "`'\"\\|,.!?/;:<>[]{}@#$%^&*()+=", "" );
        st_reduce_spaces( buf );
        st_trim( buf );
        strcat( buf, "\n" );
        count = strlen( buf );
        for ( i = 0 ; i < count ; ++i )
        {
            if ( buf[i] == '\n' )
            {
                if ( inword )
                    word_done = TRUE ;
            }
            else if ( isspace(buf[i]) )
            {
                if ( inword )
                    word_done = TRUE ;
                inword = FALSE ;
            }
            else if ( ! inword )
            {
                inword = TRUE ;
                word_done = FALSE ;
                kw += 1 ;
            }
            if ( inword )
            {
                word[w] = buf[i] ;
                w += 1 ;
                word[w] = EOS ;
            }
            if ( word_done )
            {
                st_trim( word );
                if ( strlen( word ) >= siz_out )
                    fprintf( oFh, "%s\n", word );
                ST_CLR( word );
                w = 0 ;
                word_done = FALSE ;
            }
        }
    }
    if (bytes)
        printf( "%8ld ", kc );
    if (words)
        printf( "%7ld ", kw );
    if (lines)
        printf( "%6ld ", kl );
    printf("%s\n", f);

    /* ..accumulate totals.. */
    tkc += kc;
    tkw += kw;
    tkl += kl;
}


void    main( int argc, char *argv[] )
{
    char *s;

    /* ..process switches.. */
    while (--argc > 0 && (**++argv == '-' || **argv == '/'))
    {
        for (s = *argv+1; *s; ++s)
            switch(tolower(*s))
            {
                case 'l':
                    lines = !lines;
                    break;
                case 'w':
                    words = !words;
                    break;
                case 'c':
                    bytes = !bytes;
                    break;
                case 'f':
                    files = !files;
                    break;
                default :
                    fprintf(stderr,"---> ERROR: bad option: -%c\n",*s);
                    exit( 1 );
            }
    }

    /* ..set all three options by default.. */
    if (!(bytes || words || lines))
        bytes = words = lines = TRUE ;

    /* ..initialize totals.. */
    tkc = tkl = tkw = 0;

    oFh = fl_create_or_replace_tty( oFh, oFile, "w", YES, YES );

//  headings
    if (bytes)
        printf("   bytes ");
    if (words)
        printf("  words ");
    if (lines)
        printf(" lines ");
    printf("\n");
    if (bytes)
        printf("-------- ");
    if (words)
        printf("------- ");
    if (lines)
        printf("------ ");
    printf("\n");

    /* ..process files.. */
    if ( argc == 0 )
    {
//      wc( "" );
    }
    else
    {
        /* ..check file switch.. */
        if ( argc > 1 )
            files = TRUE ;

        for ( ; *argv ; ++argv )
        {
            if ( ( iFh = fopen( *argv, "r" ) ) == NULL )
            {
                fprintf( stderr, "Cannot open file %s\a\n", *argv );
            }
            else
            {
                wc( *argv );
                fclose( iFh );
            }
        }
    }

    /* ..print totals.. */
    if ( files )
    {
        if (bytes)
            printf("-------- ");
        if (words)
            printf("------- ");
        if (lines)
            printf("------ ");
        printf("\n");
        if (bytes)
            printf( "%8ld ", tkc );
        if (words)
            printf( "%7ld ", tkw );
        if (lines)
            printf( "%6ld ", tkl );
        printf("\n");
    }
    _fcloseall();
    exit( 0 );
}
